import * as monaco from '@codingame/monaco-vscode-editor-api';
import type { OpenEditor } from '@codingame/monaco-vscode-editor-service-override';
import { LogLevel } from '@codingame/monaco-vscode-api';
import { type ViewsConfig, type VscodeApiConfig } from 'monaco-languageclient/vscode/services';
export type OverallConfigType = 'extended' | 'classic';
export interface VscodeServicesConfig {
    vscodeApiConfig: VscodeApiConfig;
    logLevel: LogLevel;
    semanticHighlighting?: boolean;
}
/**
 * Child classes are allow to override the services configuration implementation.
 */
export declare const augmentVscodeApiConfig: ($type: OverallConfigType, config: VscodeServicesConfig) => Promise<VscodeApiConfig>;
export declare const augmentHighlightingServices: ($type: OverallConfigType, services: monaco.editor.IEditorOverrideServices) => Promise<void>;
export declare const augmentViewsServices: (services: monaco.editor.IEditorOverrideServices, viewsConfig?: ViewsConfig) => Promise<void>;
/**
 * Adding the default workspace config if not provided
 */
export declare const augmentWorkspaceConfig: (vscodeApiConfig: VscodeApiConfig) => void;
/**
 * set the log-level via the development settings
 */
export declare const augmentDevLogLevel: (vscodeApiConfig: VscodeApiConfig, logLevel: LogLevel) => void;
/**
 * enable semantic highlighting in the default configuration
 */
export declare const augmentSemanticHighlighting: (vscodeApiConfig: VscodeApiConfig, semanticHighlighting?: boolean) => void;
export declare const useOpenEditorStub: OpenEditor;
export declare const checkServiceConsistency: (userServices?: monaco.editor.IEditorOverrideServices) => boolean;
//# sourceMappingURL=services.d.ts.map